// import 'package:flutter/material.dart';
// import 'package:flutter/widgets.dart';
// import 'package:sunny_platform_widgets/sunny_platform_widgets.dart';
// import 'package:logging/logging.dart';
// import 'package:sunny_dart/sunny_dart.dart';
// import 'package:sunny_forms/auto_layout.dart';
//
// import 'package:sunny_forms/text_widgets.dart';
// import 'package:sunny_lifecycle/analytics_service.dart';
//
// typedef WidgetDataBuilder<I> = Widget Function(I input);
// typedef WidgetContextDataBuilder<I> = Widget Function(
//     BuildContext context, I input);
// typedef WidgetErrorBuilder = Widget Function(Object err, StackTrace stack);
// typedef SimpleWidgetBuilder = Widget Function();
//
// //typedef WidgetBuilder = Widget Function();
// final _log = Logger("snapshots");
//
// class Snapshots {}
//
// final loadingIndicator = Center(child: PlatformCircularProgressIndicator());
// final sliverLoadingIndicator =
//     sliverBox(Center(child: PlatformCircularProgressIndicator()));
//
// extension SnapshotExtensions<X> on AsyncSnapshot<X> {
//   Widget render(
//     BuildContext context, {
//     @required WidgetDataBuilder<X> successFn,
//     WidgetErrorBuilder errorFn,
//     bool isSliver = false,
//     SimpleWidgetBuilder loadingFn,
//     bool allowNull = false,
//     bool crossFade = true,
//   }) {
//     loadingFn ??= () => loadingIndicator;
//     if (isSliver == true) {
//       final _oldFn = loadingFn;
//       loadingFn = () => sliverBox(_oldFn());
//     }
//
//     errorFn ??= (Object err, StackTrace stack) {
//       _log.severe(
//           "Error rendering snapshot!: $err", err, stack ?? StackTrace.current);
//       analytics.encounteredError(err, stack, "Rendering snapshot $X");
//       return Layout.container().alignCenter.padAll(16).single(
//             context.richText(
//               (_) => _
//                   .center()
//                   .color(Colors.red)
//                   .body1("There was a problem loading: $err"),
//             ),
//           );
//     };
//     if (isSliver == true) {
//       final _oldErr = errorFn;
//       errorFn = (err, stack) => sliverBox(_oldErr(err, stack));
//     }
//     Widget widget;
//     if (hasError) {
//       widget = errorFn(this.error, null);
//     } else if (hasData || allowNull == true) {
//       widget = successFn(data);
//     } else {
//       widget = loadingFn();
//     }
//     return (crossFade != true || isSliver == true)
//         ? widget
//         : AnimatedSwitcher(duration: 300.ms, child: widget);
//   }
// }
//
// extension StreamWidgetBuilder<T> on Stream<T> {
//   Widget build(
//       {WidgetDataBuilder<T> builder,
//       bool allowNull = false,
//       bool isSliver = false,
//       WidgetBuilder loadingBuilder,
//       T initial,
//       Key key}) {
//     return StreamBuilder<T>(
//       key: key,
//       builder: (context, snap) {
//         return snap.render(
//           context,
//           isSliver: isSliver,
//           successFn: builder,
//           loadingFn:
//               loadingBuilder == null ? null : () => loadingBuilder(context),
//           allowNull: allowNull,
//         );
//       },
//       initialData: initial,
//     );
//   }
// }
//
// extension FutureWidgetExt<T> on Future<T> {
//   Widget build(WidgetDataBuilder<T> builder,
//       {Key key, SimpleWidgetBuilder loading, bool crossFade = true}) {
//     return FutureBuilder<T>(
//       future: this,
//       key: key,
//       builder: (context, snap) {
//         return snap.render(
//           context,
//           crossFade: crossFade,
//           loadingFn: loading,
//           successFn: builder,
//         );
//       },
//     );
//   }
//
//   Widget buildContext(
//       {WidgetContextDataBuilder<T> builder, T initialValue, Key key}) {
//     return StreamBuilder<T>(
//       key: key,
//       stream: Stream.fromFuture(this),
//       initialData: initialValue,
//       builder: (context, snap) =>
//           snap.render(context, successFn: (data) => builder(context, data)),
//     );
//   }
// }
